Better GCD
Status: New Start date: 15 Apr 2012

Priority: Normal Due date:  

Assignee:  % Done: 0%

Category: New Function Estimated time: 15.00 hours

Target version: CoCoALib-1.0 Spent time: 4.75 hours

Description

Currently CoCoALib computes GCDs using GBasis/syzygy computations.  This is often terribly slow -- there is faster code in CoCoA

4 for certain special cases.  This faster code should be called whenever possible.

Related issues:

Related to CoCoALib - Feature #127: Convert DUPFF code to C++ In Progress 05 Apr 2012

Related to CoCoALib - Slug #675: Matrix determinant over multivariate poly ring In Progress 28 Mar 2015

Related to CoCoA-5 - Slug #480: gcd too slow for large degree univariate poly New 18 Mar 2014

Related to CoCoALib - Slug #952: GCD very slow Closed 25 Oct 2016

Related to CoCoALib - Feature #987: GCD: add special case if args are monomials New 28 Nov 2016

Related to CoCoALib - Slug #1359: gcd: low degree but big coeffs can be slow New 30 Oct 2019

History

#1 - 15 Apr 2012 21:59 - John Abbott

Implemented a first version where some GCD computations are passed to the old CoCoA-4 code.  It is a poor implementation (uses globals, leaks

memory).

Speed gain was disappointing for multivariate over QQ.

Good speed gain for univariate over small Fp.

#2 - 24 Apr 2012 11:17 - John Abbott

I cleaned the code so that it leaks less memory now.

The cleaning was a consequence of some other development.

#3 - 21 Dec 2012 15:57 - John Abbott

(copied from some old handwritten notes)

GCD univ over QQ and ZZ  (with normalization)

.............  Fp        (..................)

..............  other    (???)

Multivariate over QQ and ZZ

................. Fp

................. other

C4 uses builtin if char=0, o/w uses syzygies.
#4 - 01 Apr 2014 17:35 - Anna Maria Bigatti

- Target version set to CoCoALib-0.99533 Easter14

#5 - 01 Apr 2014 18:51 - Anna Maria Bigatti

- Category set to New Function

#6 - 07 Apr 2014 14:40 - John Abbott

- Target version changed from CoCoALib-0.99533 Easter14 to CoCoALib-0.99534 Seoul14

#7 - 09 Jul 2014 18:08 - John Abbott

- Target version changed from CoCoALib-0.99534 Seoul14 to CoCoALib-1.0

#8 - 24 Nov 2016 13:20 - John Abbott

- Related to Slug #480: gcd too slow for large degree univariate poly added

#9 - 28 Nov 2016 21:51 - John Abbott

- Related to Slug #952: GCD very slow added

#10 - 28 Nov 2016 22:17 - John Abbott

- Related to Feature #987: GCD: add special case if args are monomials added

#11 - 30 Oct 2019 22:34 - John Abbott

- Related to Slug #1359: gcd: low degree but big coeffs can be slow added
